$  Ver = F$Verify( F$Int(F$TRNLNM("COM$DEBUG")) )
$  GOTO Start
$!
$! Procedure:  RCS_SETUP.COM
$! Author:     Nelson E. Ingersoll
$! Date:       04-FEB-2001
$! Revision:   1.1
$!
$!    This procedure defines the various symbols and logicals required by
$!    the RCS software.  See the tail of the file for additional information.
$!
$!==============================================================================
$! Init Date    Rev     Description
$! ---- ------- ------- --------------------------------------------------------
$! NEI                  Initial implementation.
$!==============================================================================
$!
$ Start:
$  SET ON
$  ON ERROR       THEN GOTO Egress
$  ON CONTROL_Y   THEN GOTO Egress
$!
$  !IF( p1 .EQS. "?" ) THEN GOTO Usage
$!
$! NOTE: I use process logicals here because they are harder to hijack.
$!
$  DEFINE   := DEFINE/PROCESS/NOLOG    ! Very intentional.  Don't change!
$  SAY      := WRITE SYS$OUTPUT
$!
$! These definitions don't normally need to be changed as long as the
$! directory tree looks like this:
$!
$!    [.?]        Root of the RCS installation.  Bury it as desired.
$!    [.?.BIN]    Where RCS and DIFF executables are to be found.
$!    [.?.DCL]    Where this procedure & all other DCL procedures are located.
$!    [.?.HELP]   Where the RCS_HELP.HLB file is located.
$!
$! This file makes all logical name and symbol assignments which are
$! necessary to use RCS v5.7.  It's all smoke and mirrors with VMS.
$!
$  ThisDir  = F$Environment("PROCEDURE")   ! Where am we?
$  ThisDir  = F$Parse(ThisDir,,,"DEVICE") + F$Parse(ThisDir,,,"DIRECTORY")
$  RCSTrunk = ThisDir - ".DCL]"
$!
$  DEFINE DIFF$BIN     "''RCSTrunk'.BIN]"
$  DEFINE RCS$BIN      "''RCSTrunk'.BIN]"
$  DEFINE RCS$DCL      "''RCSTrunk'.DCL]"
$  DEFINE RCS$HELP     "''RCSTrunk'.HELP]"
$  DEFINE RCS$SRC      "''RCSTrunk'.SRC]"
$!
$! Look at SETRCS.COM and RCS$REFERENCE_DIRECTORIES.COM!  They both have
$! a lot to say about the logical RCS$REFDIR.
$!
$  DEFINE RCS$REFDIR   [.RCS]   ! Default RCS$REFDIR ... DON'T TOUCH!
$!
$  CI          :== @RCS$DCL:CIWILD.COM
$  CIX         :== $RCS$BIN:CI.EXE
$!
$  CO          :== @RCS$DCL:COWILD.COM
$  COX         :== $RCS$BIN:CO.EXE
$!
$  LOCKS       :== @RCS$DCL:RLOGWILD.COM """""""-L""""""" """""""-R""""""
$!
$  IDENT       :== $RCS$BIN:IDENT.EXE
$  MERGE       :== $RCS$BIN:MERGE.EXE
$!
$  RCS         :== @RCS$DCL:RCSWILD.COM
$  RCSX        :== $RCS$BIN:RCS.EXE
$!
$  RC*lean     :== @RCS$DCL:RCLEANWILD.COM
$  RCSC*lean   :== $RCS$BIN:RCSCLEAN.EXE
$!
$  RCSD*iff    :== $RCS$BIN:RCSDIFF.EXE
$  RD*iff      :== @RCS$DCL:RDIFFWILD.COM
$!
$  RLOG        :== @RCS$DCL:RLOGWILD.COM
$  RLOGX       :== $RCS$BIN:RLOG.EXE
$!
$  RCSM*erge   :== $RCS$BIN:RCSMERGE.EXE
$  SETRCS      :== @RCS$DCL:SETRCS.COM
$!
$  UDIFF       :== $DIFF$BIN:DIFF.EXE
$  UDIFF3      :== $DIFF$BIN:DIFF3.EXE
$!
$  RCSH*elp    :== HELP/LIBRARY=RCS$HELP:RCS_HELP RCS
$!
$  GOTO Egress
$!
$  Usage:
$     TYPE SYS$INPUT

                               RCS_SETUP.COM

    This command procedure sets up the logicals and symbols necessary to
    use the RCS programs.  Type HELP/LIBR=RCS$HELP:RCS_HELP.HLB RCS to get
    some help using the RCS v5.7 software on this system... or once you 
    invoke this program simply type RCSH.

$!
$  GOTO Egress
$!
$  Egress:
$     Stat = $Status
$     IF( F$TrnLNM("InF") .NES. "" ) THEN CLOSE InF
$     Ver = F$Verify( Ver )
$     EXIT Stat
$! 
$! While I believe that this program is useful, does what it is designed 
$! to do, and will not cause any harm to anything there is NO WAY I can 
$! guarantee this.  Therefore, USE AT YOUR OWN RISK.  Neither I nor ATMEL 
$! Corporation warrants that this won't ruin your system.  In fact, you 
$! should assume that it will until you have checked out the code on your 
$! own. 
$!
$! =====================================================================
$! Nelson E. Ingersoll             <>  Desk:     (719) 540-1263
$! Sr. Principal Software Engineer <>  FAX:      (719) 540-6998
$! ATMEL Corporation               <>  Pager:    (719) 921-7917
$! 1150 E. Cheyenne Mtn Blvd.      <>  INTERNET: ningersoll@atmel.com
$! Colorado Springs, CO  80906     <>            ningersoll@codenet.net
$! United States of America        <>
$! =================== No good deed goes unpunished! ===================
$!
$!  RCS_SETUP.COM is free software; you can redistribute it and/or modify
$!  it under the terms of the GNU General Public License as published by
$!  the Free Software Foundation; either version 2, or (at your option)
$!  any later version.
$!
$!  RCS_SETUP.COM is distributed in the hope that it will be useful,
$!  but WITHOUT ANY WARRANTY; without even the implied warranty of
$!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
$!  GNU General Public License for more details.
$!
$!  A copy of the GNU General Public License should be found in the file
$!  COPYING.TXT.  You may also get a copy of the GNU General Public License
$!  by writing to the Free Software Foundation, 675 Mass Ave, Cambridge, MA
$!  02139, USA.
