$  Ver = F$Verify(F$TrnLNM("COM$DEBUG"))
$! 
$! 
$! DCL 'STAMP' script to support RCS users in the VMS environment.
$!
$! VMS version developed by N.Ingersoll, ATMEL Corporation.
$!
$!  Copyright 1992, Nelson E. Ingersoll, ATMEL Corporation.
$!
$!  See NOTE at the end of the file for licensing information.
$!
$  ON ERROR      THEN GOTO Egress
$  ON CONTROL_Y  THEN GOTO Egress
$!
$  SAY   := WRITE SYS$OUTPUT
$!
$  IF( p1 .eqs. "" ) then goto Usage
$  IF( p2 .eqs. "" ) then goto Usage
$!
$!  The _real_ work of finding and stamping all RCS controlled revisions is
$!  done in this relatively simple loop.
$! 
$  RCSFile = F$Search("RCS$REFDIR:''p1'_v;0",1)
$  RCS_Loop:
$     IF( RCSFile .EQS. "" ) THEN GOTO End_RCS_Loop
$     RCSFile = F$Extract(0,F$Locate("_V;",RCSFile),RCSFile)
$     RCSName = F$Parse(RCSFile,,,"NAME") + F$Parse(RCSFile,,,"TYPE")
$     rlog -h 'RCSName' >SYS$SCRATCH:RCSSTAMP.TMP    ! Get revision header only.
$     OPEN/ERR=Egress/READ AFile SYS$SCRATCH:RCSSTAMP.TMP
$     Head_Loop:
$        READ/ERR=Egress/END=End_TmpFile AFile Rec
$        IF( F$Locate("head: ",Rec) .EQS. F$Length(Rec) ) THEN GOTO Head_Loop
$        ii = F$Locate(":",Rec)
$        Rec = F$Extract(ii+1,F$Length(Rec),Rec)
$        Rec = F$Edit(Rec,"TRIM")
$        SAY "rcs -q -n''p2':''Rec' ''RCSName'"
$        rcs -q -n'p2':'Rec' 'RCSName'         ! This is the STAMPER!
$        End_TmpFile:
$           CLOSE AFile
$           DELETE/NOLOG/NOCONFIRM SYS$SCRATCH:RCSSTAMP.TMP;0
$           RCSFile = F$Search("RCS$REFDIR:''p1'_v;0",1)
$        GOTO RCS_Loop
$     End_Head_Loop:
$  End_RCS_Loop:
$!
$  GOTO Egress
$!
$  Usage:
$  TYPE/PAGE SYS$INPUT
                                 RCS_STAMP.COM

    RCS_STAMP.COM is an RCS support procedure which will stamp a set of RCS
    controlled files with a user specified symbolic name.  This is useful
    because the symbolic name can be substituted for the revision number
    during check out.  Since it is unlikely that all the source modules,
    especially in a large software system, will all have the same revision
    numbers, it is difficult to pick up all the the modules that went with a
    specific release. By 'stamping' the controlled modules with a symbolic
    version, it is possible to mark a revision as being a specific release.
    The function of this procedure is to STAMP the symbol name into each
    matching RCS file.

    Usage:  @RCS_STAMP.COM <File-Spec> <Symbol_Name>

       File-Spec is required.  You must supply a valid VMS file specification
       of a file which is in the current RCS_REFERENCE_DIRECTORY.  Use only
       the normal VMS file name.  For example, use FOO*.C not FOO*.C_V.

       Symbol_Name is the symbol which you wish to stamp the controlled files
       with.  You may not use the period, '.', however, dashes and underscores
       are OK.  If there is more than one software 'product' controlled in the
       same RCS directory, it is a very good idea to symbolically mark modules
       which belong together.  To differentiate versions of the same product,
       use an integer date value appended to a product specific name. The
       symbolic name must begin with an alphabetic character.

        Examples:

            @rcs_stamp foo*.* foo_950205

            @rcs_stamp *.* v1_1

$!
$  GOTO Egress
$!
$  Egress:
$     Status = $Status
$     IF( F$TrnLnm("AFile") .NES. "" ) THEN CLOSE AFile
$!
$     IF( F$Search("'SYS$SCRATCH:RCSSTAMP.TMP") .NES. "" )
$     THEN
$        DELETE/NOLOG/NOCONFIRM SYS$SCRATCH:RCSSTAMP.TMP;*
$     ENDIF
$!
$     Ver = F$Verify(Ver)
$     EXIT Status
$! 
$! =====================================================================
$! Nelson E. Ingersoll             <>  Desk:     (719) 540-1263
$! Sr. Principal Software Engineer <>  FAX:      (719) 540-6998
$! ATMEL Corporation               <>  Pager:    (719) 921-7917
$! 1150 E. Cheyenne Mtn Blvd.      <>  INTERNET: ningersoll@atmel.com
$! Colorado Springs, CO  80906     <>            ningersoll@codenet.net
$! United States of America        <>
$! =================== No good deed goes unpunished! ===================
$! 
$!  RCS_STAMP.COM is free software; you can redistribute it and/or modify
$!  it under the terms of the GNU General Public License as published by
$!  the Free Software Foundation; either version 2, or (at your option)
$!  any later version.
$!
$!  RCS_STAMP.COM is distributed in the hope that it will be useful,
$!  but WITHOUT ANY WARRANTY; without even the implied warranty of
$!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
$!  GNU General Public License for more details.
$!
$!  A copy of the GNU General Public License should be found in the file
$!  COPYING.TXT.  You may also get a copy of the GNU General Public License
$!  by writing to the Free Software Foundation, 675 Mass Ave, Cambridge, MA
$!  02139, USA.

