$ Ver = F$Verify(F$TrnLNM("COM$DEBUG"))
$!
$! DCL RCSFREEZE script to support RCS users in the VMS environment.
$!
$! VMS version developed by N.Ingersoll, ATMEL Corporation.
$!
$!  Copyright 1992, Nelson E. Ingersoll, ATMEL Corporation.
$!
$!  See NOTE at the end of the file for licensing information.
$!
$ ON ERROR      THEN GOTO Egress
$ ON CONTROL_Y  THEN GOTO Egress
$!
$! Find RCS Version file, make as necessary, and increment version number.
$ RCSFridge = "RCS$REFDIR:RCSFREEZE.ver"
$!
$ RCSVersionNumber = 0
$ File = F$Search( RCSFridge )
$ IF( File .NES. "" )
$ THEN
$   OPEN/ERR=Egress/READ VFile 'File'
$   READ/ERR=Egress VFile RCSVersionNumber
$   CLOSE VFile
$   DELETE/NOLOG/NOCONFIRM 'File'
$ ENDIF
$!
$ RCSVersionNumber = RCSVersionNumber + 1
$ OPEN/ERR=Egress/WRITE VFile 'RCSFridge'
$ WRITE VFile RCSVersionNumber
$ CLOSE VFile
$!
$ SymRev = "C_''RCSVersionNumber'"
$ IF( p1 .EQS. "" ) THEN SymRevName = SymRev  ! SymRevName is superceeded by
$ IF( p1 .NES. "" ) THEN SymRevName = p1      ! any parameter from user!
$!
$! Tell the user about the revision level.
$ WRITE SYS$OUTPUT "rcsfreeze: symbolic revision number computed: ''SymRev'"
$ WRITE SYS$OUTPUT "rcsfreeze: symbolic revision number used:     ''SymRevName'"
$ WRITE SYS$OUTPUT "rcsfreeze: the two differ only when rcsfreeze invoked with an argument."
$ WRITE SYS$OUTPUT "rcsfreeze: give log message, summarizing changes (end with ^Z or single '.')"
$!
$! Get log entry now...
$!
$ RCSLogFile = "''F$Extract(0,F$Locate(".ver",RCSFridge),RCSFridge)'.logfile"
$ LogFile = F$Search(RCSLogFile)
$ IF( LogFile .NES. "" ) THEN COPY 'LogFile' RCS$REFDIR:RCSLOG.TMP
$ OPEN/ERR=Egress/WRITE  LFile RCS$REFDIR:RCSLOG.TMP
$!
$ WRITE LFile "Version: ''SymRevName'(''SymRev'), Date: ''F$Time()'"
$ WRITE LFile "------------"
$ Prompt = "> "
$ Log_Loop:
$   READ/ERR=Egress/END=End_Log_Loop/PROMPT='Prompt' SYS$COMMAND LogLine
$   IF( LogLine .EQS. "." ) THEN GOTO End_Log_Loop
$   WRITE LFile "  ''LogLine'"
$   GOTO Log_Loop
$ End_Log_Loop:
$ WRITE LFile "------------"
$ CLOSE LFile
$!
$! They were serious, so now, update the real LogFile, and clean up.
$!
$ IF( LogFile .NES. "" ) THEN DELETE/NOLOG/NOCONFIRM 'LogFile'
$ COPY RCS$REFDIR:RCSLOG.TMP;* RCS$REFDIR:RCSFREEZE.LOGFILE
$ DELETE/NOLOG/NOCONF RCS$REFDIR:RCSLOG.TMP;*
$!
$!  The _real_ work of finding and stamping all RCS controlled revisions is
$!  done in this relatively simple loop.
$!
$ RCSFile = F$Search("RCS$REFDIR:*.*_v;0",1)
$ RCS_Loop:
$   IF( RCSFile .EQS. "" ) THEN GOTO End_RCS_Loop
$   RCSFile = F$Extract(0,F$Locate("_V;",RCSFile),RCSFile)
$   RCSName = F$Parse(RCSFile,,,"NAME") + F$Parse(RCSFile,,,"TYPE")
$   rlog -h 'RCSName' >RCS$REFDIR:RCSFREEZE.TMP    ! Get revision header only.
$   OPEN/ERR=Egress/READ AFile RCS$REFDIR:RCSFREEZE.TMP
$   Head_Loop:
$     READ/ERR=Egress/END=End_TmpFile AFile Rec
$     IF( F$Locate("head: ",Rec) .EQS. F$Length(Rec) ) THEN GOTO Head_Loop
$       ii = F$Locate(":",Rec)
$       Rec = F$Extract(ii+1,F$Length(Rec),Rec)
$       Rec = F$Edit(Rec,"TRIM")
$       WRITE SYS$OUTPUT "rcsfreeze: ''Rec'	''RCSName'"
$       rcs -q -n'SymRevName':'Rec' 'RCSName' ! This is the STAMPER!
$     End_TmpFile:
$       CLOSE AFile
$       DELETE/NOLOG/NOCONFIRM RCS$REFDIR:RCSFREEZE.TMP;0
$       RCSFile = F$Search("RCS$REFDIR:*.*_v;0",1)
$     GOTO RCS_Loop
$   End_Head_Loop:
$ End_RCS_Loop:
$!
$ Egress:
$   Status = $Status
$   IF( F$TrnLnm("AFile") .NES. "" ) THEN CLOSE AFile
$   IF( F$TrnLnm("LFile") .NES. "" ) THEN CLOSE LFile
$   IF( F$TrnLnm("VFile") .NES. "" ) THEN CLOSE VFile
$   IF( F$Search("RCS$REFDIR:RCSLOG.TMP") .NES. "" ) THEN -
      DELETE/NOLOG/NOCONFIRM RCS$REFDIR:RCSLOG.TMP;*
$   IF( F$Search("RCS$REFDIR:RCSFREEZE.TMP") .NES. "" ) THEN -
      DELETE/NOLOG/NOCONFIRM RCS$REFDIR:RCSFREEZE.TMP;*
$! 
$   Ver = F$Verify(Ver)
$   EXIT Status
$!==============================================================================
$!
$! NOTES:
$!
$!  I picked up a UNIX shell script called rcsfreeze.sh from prep.ai.mit.edu
$!  from the GNU release of RCS v5.6.  The script, and apparently the rest of
$!  the RCS release, is copyright Paul Eggert (1990,1991) under the terms of
$!  the GNU General Public License as published by the Free Software
$!  Foundation.  I am using RCS v4.3 as ported to VMS by Richard Gregory.
$!  Richard... thanks!  RCS for VMS is a winner!  Thanks should also go to
$!  the many folks who bring us the main version of RCS, now at v5.6, for
$!  UNIX.
$!
$!  This version of RCSFREEZE was "thrown" together in a day and a half.
$!  It works essentially the same as rcsfreeze.sh under UNIX.  The VMS
$!  filesystem casually maintains multiple file versions and it is the job
$!  of the user to purge the [.RCS] directory periodically to keep the
$!  directory clean.  Note that RCSFREEZE keep RCSFREEZE.VER and 
$!  RCSFREEZE.LOGFILE files at one version, but the RCS controlled files are 
$!  not, and after every freeze there will be an extra version of each RCS 
$!  controlled file.
$!
$!  You can stop RCSFREEZE at any time.  However, if you do so once RCSFREEZE
$!  has started looking for RCS controlled files, you run the risk of making
$!  the RCS dir out of RCS kilter.  I may do something about this in the
$!  future, if I can decide what the safest methodology is.
$!
$!  Not clearly mentioned in the RCSFREEZE documentation is the method of
$!  recovering an previous version level.  When RCSFREEZE "freezes" code it
$!  actually assigns a revision symbol, typically C_<number> which is put
$!  into the RCS header of all affected files.  Use the revision symbol name
$!  in conjunction with CO to retrieve a specific code revision. My copy of
$!  RCSFREEZE should be accompanied by several other command procedures which
$!  give the user wildcard capabilities under VMS.  If one wished to retrieve
$!  a major "frozen" revision level, say C_3, of all modules (the raison
$!  d'etre of RCSFREEZE!), using COWILD.COM, they would use the command
$!  "@COWILD -rC_3 *.*". All of the appropriate RCS controlled revision
$!  levels of the source files would be retrieved.  Assuming that you then
$!  decided to delete those files using RCLEANWILD.COM, you would use the
$!  command "@RCLEANWILD -rC_3 *.*" and all, unchanged, from symbolic version
$!  C_3, files will be cleaned, i.e. deleted.
$!
$!  RCSFREEZE.COM is free software; you can redistribute it and/or modify
$!  it under the terms of the GNU General Public License as published by
$!  the Free Software Foundation; either version 2, or (at your option)
$!  any later version.
$!
$!  RCSFREEZE.COM is distributed in the hope that it will be useful,
$!  but WITHOUT ANY WARRANTY; without even the implied warranty of
$!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
$!  GNU General Public License for more details.
$!
$!  A copy of the GNU General Public License should be found in the file
$!  COPYING.TXT.  You may also get a copy of the GNU General Public License
$!  by writing to the Free Software Foundation, 675 Mass Ave, Cambridge, MA
$!  02139, USA.
$!
$!  Report problems and direct all questions about RCSFREEZE.COM to me please.
$!
$!  Nelson E. Ingersoll
$!  December 1992.
$!
$! =====================================================================
$! Nelson E. Ingersoll             <>  Desk:     (719) 540-1263
$! Sr. Principal Software Engineer <>  FAX:      (719) 540-6998
$! ATMEL Corporation               <>  Pager:    (719) 921-7917
$! 1150 E. Cheyenne Mtn Blvd.      <>  INTERNET: ningersoll@atmel.com
$! Colorado Springs, CO  80906     <>            ningersoll@codenet.net
$! United States of America        <>
$! =================== No good deed goes unpunished! ===================
