$  Ver = F$Verify( F$TrnLNM("COM$DEBUG") )
$!
$! RLOG.EXE with wildcards.  See description at end of file.
$!
$! Auth:  N.Ingersoll, 10-NOV-1992
$!
$  ON ERROR      THEN CONTINUE
$  ON CONTROL_Y  THEN GOTO Egress
$!
$  IF( p1 .EQS. "?" ) THEN GOTO Usage
$!
$! What kind of OpenVMS system is this?  NOTE: VAX systems will have an
$! "_VAX" appended to the filename and Alpha systems will have an ''
$! appended to the file names.  Soon enough there won't be any VAX
$! systems in production mode at ATMEL/CSO.  <sigh>  The passing of an
$! era.
$!
$  IF( F$GetSYI("ARCH_NAME") .EQS. "Alpha" )
$  THEN
$     CPU_TYPE == ""
$  ELSE
$     CPU_TYPE == "_VAX"
$  ENDIF
$!
$  DASH     = "-"
$  DBLDASH  = "--"
$  QUOTE    = """
$!
$  RLOGEXE := $RCS$BIN:RLOG'CPU_TYPE'.EXE
$  SAY     := WRITE SYS$OUTPUT
$!
$  IF( p1 .EQS. "" )
$  THEN
$     RLOGEXE
$     GOTO Egress
$  ENDIF
$!
$  nn = 1
$  WC_Flag = 0
$  Check_WC_Loop:
$     IF( F$Locate("*",p'nn') .LT. F$Length(p'nn') ) THEN WC_Flag = 1
$     IF( F$Locate("%",p'nn') .LT. F$Length(p'nn') ) THEN WC_Flag = 1
$     nn = nn + 1
$     IF( (nn .GT. 8) .OR. (p'nn' .EQS. "") ) THEN GOTO End_Check_WC_Loop
$     GOTO Check_WC_Loop
$  End_Check_WC_Loop:
$!
$  Max_nn = nn - 1 ! The highest parameter, by number, found.
$!
$!  If wildcards are not used, we simply do it and get out.
$!
$  IF( .NOT. WC_Flag )
$  THEN
$     nn = 1
$     Params = ""
$     BUILD_Param_Loop:
$        IF( nn .GT. Max_nn ) THEN GOTO End_BUILD_Param_Loop
$        IF( (F$Extract(0,1,p'nn').EQS.DASH).OR.(F$Extract(0,1,p'nn').EQS.QUOTE) )
$        THEN
$           IF( F$Extract(0,2,p'nn').EQS.DBLDASH)
$           THEN
$              p'nn' = p'nn' - DASH
$              Params = Params + " " + QUOTE + p'nn' + QUOTE
$           ELSE
$              Params = Params + " " + p'nn'
$           ENDIF
$        ELSE
$           Params = Params + " " + p'nn'
$        ENDIF
$        nn = nn + 1
$        GOTO BUILD_Param_Loop
$     End_BUILD_Param_Loop:
$     RLOGEXE 'Params'
$     GOTO Egress
$  ENDIF
$!
$  Params = ""     ! The concatenated list of parameters.
$  Files1 = ""     ! The concatenated list of files.  See doc at EOF.
$  fn     = 1
$  nn     = 1
$!
$  Done = 0
$  Params_Loop:    ! Parameters must precede file specifications.  This is an
$                  ! RCS restriction we'll preserve.
$     IF( (p'nn' .NES. "") .AND. (nn .LE. Max_nn) )
$     THEN
$        IF( (F$Extract(0,1,p'nn').EQS.DASH).OR.(F$Extract(0,1,p'nn').EQS.QUOTE) )
$        THEN
$           IF( F$Extract(0,2,p'nn').EQS.DBLDASH)
$           THEN
$              p'nn' = p'nn' - DASH
$              Params = Params + " " + QUOTE + p'nn' + QUOTE
$           ELSE
$              Params = Params + " " + p'nn'
$           ENDIF
$           nn = nn + 1
$        ELSE
$           Done = 1
$        ENDIF
$     ENDIF
$     IF( .NOT. Done ) THEN GOTO Params_Loop
$  End_Params_Loop:
$!
$  Files_Loop:
$     FName = ""
$     Search_Loop:
$        Pat = "RCS$REFDIR:" + p'nn' + "_V"
$        Spec = F$SEARCH( Pat )
$        IF( Spec .NES. "" )
$        THEN
$           TYPE = F$Parse(Spec,,,"TYPE")
$           FName = F$Parse(Spec,,,"NAME") + F$Extract(0,F$Length(TYPE)-2,TYPE)
$           IF( F$Length(Files'fn') .GE. 132 )
$           THEN
$              fn = fn + 1
$              Files'fn' = ""
$           ENDIF
$           Files'fn' = Files'fn' + " " + FName
$        ENDIF
$        IF( Spec .NES. "" ) THEN GOTO Search_Loop
$     End_Search_Loop:
$     nn = nn + 1
$     IF( nn .LE. Max_nn ) THEN GOTO Files_Loop
$  End_Files_Loop:
$!
$  Start_Check_Out:
$     nn = 1
$     Execute_Loop:
$        Files = Files'nn'
$        IF( F$EDIT(Files,"TRIM,COMPRESS") .NES. "" )
$        THEN
$           SET NOON
$           RLOGEXE  'Params' 'Files'
$           SET ON
$        ENDIF
$        IF( nn .GE. fn ) THEN GOTO End_Execute_Loop
$        nn = nn + 1
$        GOTO Execute_Loop
$     End_Execute_Loop:
$  GOTO Egress
$!
$  Usage:
$     TYPE SYS$INPUT:

                               RLOGWILD.COM

    RLOGWILD.COM is a DCL wrapper for the GNU RCS rlog program.  It helps 
    VMS emulate the UNIX trick of expanding filenames before the program 
    is called.  It also allows the user to force the case of the options.  
    In the case of options which MUST remain in UPPERcase, simply use the 
    normal rlog option but add an additional dash, '-', to its start.
    
    Usage:
    
        $ rlog <options> <filespec>
    
    Examples:
    
        $ rlog --R *.c *.h
        
        $ rlog xyz.com
        
$!
$ Egress:
$   Status = $Status
$   Ver = F$Verify( Ver )
$   EXIT Status
$!
$! =====================================================================
$! Nelson E. Ingersoll             <>  Desk:     (719) 540-1263
$! Sr. Principal Software Engineer <>  FAX:      (719) 540-6998
$! ATMEL Corporation               <>  Pager:    (719) 921-7917
$! 1150 E. Cheyenne Mtn Blvd.      <>  INTERNET: ningersoll@atmel.com
$! Colorado Springs, CO  80906     <>            ningersoll@codenet.net
$! United States of America        <>
$! =================== No good deed goes unpunished! ===================
$!
$!  RDIFFWILD.COM is free software; you can redistribute it and/or modify
$!  it under the terms of the GNU General Public License as published by
$!  the Free Software Foundation; either version 2, or (at your option)
$!  any later version.
$!
$!  RDIFFWILD.COM is distributed in the hope that it will be useful,
$!  but WITHOUT ANY WARRANTY; without even the implied warranty of
$!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
$!  GNU General Public License for more details.
$!
$!  A copy of the GNU General Public License should be found in the file
$!  COPYING.TXT.  You may also get a copy of the GNU General Public License
$!  by writing to the Free Software Foundation, 675 Mass Ave, Cambridge, MA
$!  02139, USA.
$!
$!                 ----------------------------------------
$!
$!    RCS programs expect that file specifications follow the parameter list.
$! This is preserved in this command procedure.  If you mixed them in the
$! command line RLOG may not behave as expected.
$!
$!    RCS files can be paired.  Read the RLOG.DOC, et al, file.  I am
$! not certain at this time (10-Nov-1992) what function this serves, but I
$! want to preserve it.  It is assumed in this procedure that such pairing
$! would not include wildcard file specifications.  Therefore, if no wildcards
$! are used (or if output redirection is specified) and normal, no frills,
$! RLOG command is used.  Output redirection will supersede wildcarding,
$! which means that wildcards and output redirection are incompatible.
$!
$!    Given the nature of programming, (or is it just me?), it is quite
$! possible that a wildcard file specification will result in so many
$! filenames that the DCL command line limit of 255 characters would not
$! hold them all.  To help avoid this limitation I designed this DCL code to
$! build more than one file list, as necessitated by wildcarding, and perform
$! a run against each list.  Too help avoid the combined length of the file
$! list, parameter list and program command from exceeding 255 characters,
$! each file list is limited to around 132 characters.  Things could still go
$! wrong, but the likelihood is much smaller.
$!
$!============================= Revision History =============================
$!  Date      Name              Comment
$!----------- ----------------- ----------------------------------------------
$!04-Aug-1992 N.Ingersoll       Made it work with all input, WC'd and not.
$!============================================================================
