$  Ver = F$Verify( F$Int(F$TRNLNM("COM$DEBUG")) )
$  GOTO Start
$!
$! Procedure:   SetRCS.COM
$! Author:      Nelson E. Ingersoll
$! Date:        20-SEP-1995
$! Revision:    1.0
$!
$!      Assigns RCS$REFDIR Logical to the appropriate directory.
$!
$!==============================================================================
$! Init Date    Rev     Description
$! ---- ------- ------- --------------------------------------------------------
$! NEI  20Sep95 1.0     Command procedure to set the RCS library directory.
$!==============================================================================
$!
$  Start:
$!
$  ON ERROR        THEN GOTO Egress
$  ON CONTROL_Y    THEN GOTO Egress
$!
$  DEFINE   := DEFINE/PROCESS/NOLOG
$  SAY      := WRITE SYS$OUTPUT
$  SPACES    = "                                        "
$  SPACES    = SPACES + "                                        "
$!
$  Def_RCS = "[.RCS]    "
$  ESC[0,7] = 27
$  Blanks = "          "
$!
$  IF( p1 .EQS. "?" )
$  THEN
$     Say "RCS Directory: ", F$TrnLNM("RCS$REFDIR")
$     GOTO Egress
$  ENDIF
$!
$  IF( p1 .EQS. "HELP" ) THEN GOTO Usage
$!
$  IF( F$TrnLNM("RCS$REFDIR") .EQS. "" ) THEN DEFINE RCS$REFDIR [.RCS]
$!
$  @RCS$DCL:RCS$REFERENCE_DIRECTORIES.COM
$!
$! We use the logical RCS$Reference_Directories as a list logical.  Here that
$! logical is translated until there are no more entries.  Those entries
$! become the list we display.
$!
$! See the command procedure RCS$REFERENCE_DIRECTORIES.COM for information
$! on setting up the logical RCS$Reference_Directories.
$!
$  Index = 0
$  RCSLibraries = ""
$  Translate_Loop:
$     Temp = F$TrnLNM("rcs$reference_directories","LNM$JOB",Index)
$     IF( F$Edit(Temp,"TRIM") .EQS. "" ) THEN GOTO End_Translate_Loop
$     Temp = Temp - "RCS$"
$     Temp = "''Temp'''F$Extract(0,10-F$Length(Temp),Blanks)'"
$     IF( RCSLibraries .EQS. "" )
$     THEN
$        RCSLibraries = "''Temp'"
$     ELSE
$        RCSLibraries = "''RCSLibraries',''Temp'"
$     ENDIF
$     Index = Index + 1
$     GOTO Translate_Loop
$  End_Translate_Loop:
$!
$  Interactive = 0
$  IF( p1 .NES. "" ) THEN GOTO Check_Choice
$  Interactive = 1
$!
$  Display_Choices:
$!
$     II = F$Length(F$TrnLNM("RCS$REFDIR"))
$     II = (50 - II)/2 + 10
$     Padding = F$Extract(0,II,SPACES)
$!
$     TYPE/PAGE NL:
$     Say ""
$     Say "''ESC'#6        ''ESC'[7mATMEL RCS Libraries''Esc'[0m"
$     Say ""
$     Say "''Padding'''ESC'[1m''F$TrnLNM("RCS$REFDIR")'''Esc'[0m"
$     Say ""
$!
$     Cnt = 0
$     Lev = 1
$     Line_Out = ""
$     Loop_Choices:
$        Num  = F$String(Cnt+1)
$        IF( Cnt .LT. 9 ) THEN Num = " ''Num'"
$        Name = F$Element( Cnt, ",", RCSLibraries )
$        IF( Name .EQS. "," )
$        THEN
$           IF( Line_Out .NES. "" )
$           THEN
$              Say "        ", Line_Out
$           ENDIF
$        ELSE
$           Line_Out = "''Line_Out'  ''Num' - ''Esc'[1m''Name' ''Esc'[0m"
$           Cnt = Cnt + 1
$           Lev = Lev + 1
$           IF( Lev .EQ. 4 )
$           THEN
$              Lev = 1
$              Say "        ", Line_Out
$              Line_Out = ""
$           ENDIF
$           GOTO Loop_Choices
$        ENDIF
$     End_Loop_Choices:
$     Say " "
$     Say " "
$!
$     Prompt = "          Select an RCS library (Number or Name): "
$     READ/Err=Egress/Prompt="''Prompt'" SYS$COMMAND p1
$     IF( p1 .EQS. "" )
$     THEN
$        Say ""
$        Say "RCS Directory: ", F$TrnLNM("RCS$REFDIR")
$        GOTO Egress
$     ENDIF
$     p1 := 'p1'
$!
$  End_Display_Choices:
$!
$  Check_Choice:
$!
$     IF( p1 .EQS. "?" )
$     THEN
$        Say ""
$        Say "RCS Library = ''Esc'[1m''F$TrnLNM("RCS$REFDIR")'''Esc'[0m"
$        Say ""
$        GOTO Egress
$     ENDIF
$!
$     Num = 0
$     IF( F$Type(p1) .EQS. "INTEGER" ) THEN Num = F$Integer(p1)
$!
$     IF( Num .GT. 0 ) THEN p1 = F$Element(Num-1,",",RCSLibraries)
$!
$     p1 = "''p1'''F$Extract(0,10-F$Length(p1),Blanks)'"
$     IF( F$Locate(p1,RCSLibraries) .NE. F$Length(RCSLibraries) )
$     THEN
$        IF( p1 .EQS. Def_RCS )
$        THEN
$           RCSDIR = F$Parse(p1,,,"DIRECTORY")
$           RCSDEV = F$Parse(p1,,,"DEVICE")
$           DEFINE RCS$REFDIR "''RCSDEV'''RCSDIR'"
$        ELSE
$           DEFINE RCS$REFDIR "RCS$''F$Edit(p1,"TRIM")':"
$        ENDIF
$     ELSE
$        RCSDIR = F$Parse(p1,,,"DIRECTORY")
$        RCSDEV = F$Parse(p1,,,"DEVICE")
$        p1 = "''RCSDEV'''RCSDIR'"
$        DEFINE RCS$REFDIR 'p1'
$     ENDIF
$     Say ""
$     Say "RCS Library = ''Esc'[1m''F$TrnLNM("RCS$REFDIR")'''Esc'[0m"
$!
$  End_Check_Choice:
$  Say " "
$  GOTO Egress
$!
$  Usage:
$     TYPE/PAGE=SAVE SYS$INPUT

                                SETRCS.COM

   SETRCS.COM provides a mechanism for selecting which RCS library 
   reference directory will be used for all subsequent RCS commands.  
   SETRCS can be used interactively or non-interactively.  It defines 
   the value of the logical RCS$REFDIR.

   Usage:   @SETRCS.COM [ <name> | <number> | <userlib> | ? | HELP ]

        <name>  is the name of the RCS library directory, minus the 
                prefix string 'RCS$', as defined in the 
                RCS$REFERENCE_DIRECTORIES logical set by the the 
                RCS$REFERENCE_DIRECTORIES.COM command procedure.

        <number> is the positional number of the RCS library as defined 
                in the RCS$REFERENCE_DIRECTORIES logical.  One can simply 
                run SETRCS without any command line arguments to see the 
                positional value of predefined RCS names.

        <userlib> is the name of any directory.  Presumably the 
                directory is a functional RCS directory.  
                NOTE: SETRCS will expand partial directory specifications 
                such that one can use the command 'SETRCS []' and the 
                current directory will become the RCS reference directory.
                'SETRCS [.RCS]' will do the same.  This allows the user to 
                move to another directory any where on the system and still 
                maintain the RCS reference directory.

        ?       Show the active RCS library reference.

        HELP    Display this help screen.

    If SETRCS is invoked without any parameters it will present an 
    interactive menu from which the user can make choices from the 
    defined lists of RCS library directories.

    Examples:
    
        $ @SETRCS       ! View the currently pre-defined RCS directories 
                        ! and set one of them as the reference directory.

        $ @SETRCS 3     ! Set the RCS library to the 3rd item in the
                        ! logical RCS$REFERENCE_DIRECTORIES.

        $ @SETRCS MAKE  ! Set the RCS library to either a value in
                        ! RCS$REFERENCE_DIRECTORIES named 'RCS$MAKE' or
                        ! to the value 'MAKE'.

        $ @SETRCS DISK$HEAP:[MYDIR.RCS]
                        ! Set the RCS library to DISK$HEAP:[MYDIR.RCS]

        $ @SETRCS ?     ! Shows the current RCS reference directory.
        RCS Directory: DISK$SUPPORT:[UTILITIES.RCS57.DCL]
        $ 
                        

$!
$  Egress:
$     Stat = $Status
$     Ver = F$Verify( Ver )
$     EXIT Stat
$!
$! =====================================================================
$! Nelson E. Ingersoll             <>  Desk:     (719) 540-1263
$! Sr. Principal Software Engineer <>  FAX:      (719) 540-6998
$! ATMEL Corporation               <>  Pager:    (719) 921-7917
$! 1150 E. Cheyenne Mtn Blvd.      <>  INTERNET: ningersoll@atmel.com
$! Colorado Springs, CO  80906     <>            ningersoll@codenet.net
$! United States of America        <>
$! =================== No good deed goes unpunished! ===================
$!
$!  SETRCS.COM is free software; you can redistribute it and/or modify
$!  it under the terms of the GNU General Public License as published by
$!  the Free Software Foundation; either version 2, or (at your option)
$!  any later version.
$!
$!  SETRCS.COM is distributed in the hope that it will be useful,
$!  but WITHOUT ANY WARRANTY; without even the implied warranty of
$!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
$!  GNU General Public License for more details.
$!
$!  A copy of the GNU General Public License should be found in the file
$!  COPYING.TXT.  You may also get a copy of the GNU General Public License
$!  by writing to the Free Software Foundation, 675 Mass Ave, Cambridge, MA
$!  02139, USA.
$!

