#
#   MMK makefile for RCS v5.7 on VMS.
#
#  
#   31-JAN-2001 Nelson Ingersoll
#       Finally able to get a clean compile of all modules using DECC 
#       v6.2.  <grin>  The only messages are informational "QUESTCOMPARE1" 
#       and then there are only three in the entire build.
#       
#       
#   16-FEB-2001 Nelson Ingersoll
#       Change the assignment for RCSBIN to match your installation.
#  

# Used in 'install' target only.
RCSBIN = DISK$SUPPORT:[UTILITIES.RCS57.BIN]
#  
#  

# Set default CC rule.  I.e. override MMK_DEFAULT_RULES
.C$(OBJ) :
     $(CC) $(MMS$SOURCE)
#
#
#   We have a mixed VMScluster containing VAXen and Alpha systems.  This bit
#   of MMK code tells MMK how to deal with the different CPUs. It
#   specifically allows us to build the software in a single directory tree.
#   Object files are placed into hardware specific sub-directories and the
#   executable images have either nothing (VAX) or "_AXP" (Alpha) suffixed to
#   the image name depending on the hardware.
#
#
.ifdef __VAX__
EX          = _VAX
OB          = [.obj_vax]
CFLAGS      = /stand=vaxc/noopt/prefix=all/lis/obj=$(OB)
CC          = CC $(CFLAGS)'dbgflag'
.else
EX          = 
OB          = [.obj_axp]
CFLAGS      = /decc/noopt/prefix=all/lis/obj=$(OB)
CC          = CC $(CFLAGS)'dbgflag'
.endif

LDFLAGS = /trace/nomap'dbgflag'

LINK = LINK $(LDFLAGS)

#============================= Image Objects ==================================

CIOBJ = -
    $(OB)ci.obj,$(OB)rcslex.obj,$(OB)rcssyn.obj,$(OB)rcsgen.obj, -
    $(OB)rcsedit.obj,$(OB)rcskeys.obj,$(OB)rcsmap.obj,$(OB)rcsrev.obj, -
    $(OB)rcsutil.obj,$(OB)rcsfnms.obj,$(OB)maketime.obj,$(OB)partime.obj, -
    $(OB)rcstime.obj,$(OB)rcskeep.obj,$(OB)rcsfcmp.obj,$(OB)version.obj,-
    $(OB)vms.obj

COOBJ = -
    $(OB)co.obj,$(OB)rcslex.obj,$(OB)rcssyn.obj,$(OB)rcsgen.obj, -
    $(OB)rcsedit.obj,$(OB)rcskeys.obj,$(OB)rcsmap.obj,$(OB)rcsrev.obj, -
    $(OB)rcsutil.obj,$(OB)rcsfnms.obj,$(OB)maketime.obj,$(OB)partime.obj, -
    $(OB)rcstime.obj,$(OB)rcskeep.obj,$(OB)version.obj,$(OB)vms.obj

IDENTOBJ = $(OB)ident.obj,$(OB)rcsmap.obj,$(OB)version.obj

MERGEOBJ = -
    $(OB)merge.obj,$(OB)merger.obj,$(OB)rcsfnms.obj,$(OB)rcslex.obj, -
    $(OB)rcsmap.obj,$(OB)rcsrev.obj,$(OB)rcssyn.obj,$(OB)rcsutil.obj, -
    $(OB)rcskeep.obj,$(OB)rcskeys.obj,$(OB)maketime.obj, -
    $(OB)partime.obj,$(OB)rcstime.obj,$(OB)version.obj,$(OB)vms.obj

RLOGOBJ = -
    $(OB)rlog.obj,$(OB)rcslex.obj,$(OB)rcsmap.obj,$(OB)rcssyn.obj, -
    $(OB)rcsrev.obj,$(OB)rcsutil.obj,$(OB)maketime.obj, -
    $(OB)partime.obj,$(OB)rcstime.obj,$(OB)rcsfnms.obj, -
    $(OB)rcskeep.obj,$(OB)rcskeys.obj,$(OB)version.obj

RCSOBJ = -
    $(OB)rcs.obj,$(OB)rcslex.obj,$(OB)rcssyn.obj,$(OB)rcsrev.obj, -
    $(OB)rcsutil.obj,$(OB)rcsgen.obj,$(OB)rcsedit.obj,$(OB)rcskeys.obj, -
    $(OB)rcsmap.obj,$(OB)rcsfnms.obj,$(OB)rcskeep.obj, -
    $(OB)maketime.obj,$(OB)partime.obj,$(OB)rcstime.obj, -
    $(OB)version.obj,$(OB)vms.obj

RCSCLEANOBJ = -
    $(OB)rcsclean.obj,$(OB)rcsedit.obj,$(OB)rcsfcmp.obj,$(OB)rcsfnms.obj, -
    $(OB)rcsgen.obj,$(OB)rcskeys.obj,$(OB)rcslex.obj,$(OB)rcsmap.obj, -
    $(OB)rcsrev.obj,$(OB)rcssyn.obj,$(OB)rcsutil.obj,$(OB)rcskeep.obj, -
    $(OB)maketime.obj,$(OB)partime.obj,$(OB)rcstime.obj,$(OB)version.obj, -
    $(OB)vms.obj

RCSDIFFOBJ = -
    $(OB)rcsdiff.obj,$(OB)rcsutil.obj,$(OB)rcsfnms.obj,$(OB)rcsmap.obj, -
    $(OB)rcsrev.obj,$(OB)rcssyn.obj,$(OB)rcslex.obj,$(OB)maketime.obj, -
    $(OB)partime.obj,$(OB)rcstime.obj,$(OB)rcskeep.obj,$(OB)rcskeys.obj, -
    $(OB)version.obj

RCSMERGEOBJ = -
    $(OB)rcsmerge.obj,$(OB)merger.obj,$(OB)rcsutil.obj,$(OB)rcsfnms.obj,-
    $(OB)rcsmap.obj,$(OB)rcsrev.obj,$(OB)rcssyn.obj,$(OB)rcslex.obj, -
    $(OB)rcskeep.obj,$(OB)rcskeys.obj,$(OB)maketime.obj,$(OB)partime.obj, -
    $(OB)rcstime.obj,$(OB)version.obj

#============================= Main Targets ===================================

all :   ci co ident merge rcs rcsdiff rcsmerge rlog rcsclean
#
# Modify to suit your needs.  Otherwise expect this code to fail.
install : ci co ident merge rcs rcsdiff rcsmerge rlog rcsclean
    COPY *.exe $(RCSBIN)
#
# Target to clean the directory tree.
clean :
    DELETE [...]*.lis;*,*.obj;*
#
# Set debug flags.
debug : 
    dbgflag = "/debug"

#============================ Other Targets ===================================

ci : ci$(EX).exe
co : co$(EX).exe
ident : ident$(EX).exe
merge : merge$(EX).exe
rcs : rcs$(EX).exe
rcsclean : rcsclean$(EX).exe
rcsdiff : rcsdiff$(EX).exe
rcsmerge : rcsmerge$(EX).exe
rlog : rlog$(EX).exe

ci$(EX).exe : $(CIOBJ)
    $(LINK) /exe=ci$(EX).exe $(CIOBJ)

co$(EX).exe : $(COOBJ)
    $(LINK) /exe=co$(EX).exe $(COOBJ)

ident$(EX).exe : $(IDENTOBJ)
    $(LINK) /exe=ident$(EX).exe $(IDENTOBJ)

merge$(EX).exe : $(MERGEOBJ)
    $(LINK) /exe=merge$(EX).exe $(MERGEOBJ)

rcs$(EX).exe : $(RCSOBJ)
    $(LINK) /exe=rcs$(EX).exe $(RCSOBJ)

rcsclean$(EX).EXE : $(RCSCLEANOBJ)
    $(LINK) /exe=rcsclean$(EX).exe $(RCSCLEANOBJ)

rcsdiff$(EX).exe : $(RCSDIFFOBJ)
    $(LINK) /exe=rcsdiff$(EX).exe $(RCSDIFFOBJ)

rcsmerge$(EX).exe : $(RCSMERGEOBJ)
    $(LINK) /exe=rcsmerge$(EX).exe $(RCSMERGEOBJ)

rlog$(EX).exe : $(RLOGOBJ)
    $(LINK) /exe=rlog$(EX).exe $(RLOGOBJ)

#========================= Object Dependencies ================================
#
$(OB)ci.obj :           ci.c        rcsbase.h   conf.h
$(OB)co.obj :           co.c        rcsbase.h   conf.h
$(OB)ident.obj :        ident.c     rcsbase.h   conf.h
$(OB)maketime.obj :     maketime.c  rcsbase.h   conf.h
$(OB)merge.obj :        merge.c     rcsbase.h   conf.h
$(OB)merger.obj :       merger.c    rcsbase.h   conf.h
$(OB)partime.obj :      partime.c   rcsbase.h   conf.h
$(OB)rcs.obj :          rcs.c       rcsbase.h   conf.h
$(OB)rcsclean.obj :     rcsclean.c  rcsbase.h   conf.h
$(OB)rcsdiff.obj :      rcsdiff.c   rcsbase.h   conf.h
$(OB)rcsedit.obj :      rcsedit.c   rcsbase.h   conf.h
$(OB)rcsfcmp.obj :      rcsfcmp.c   rcsbase.h   conf.h
$(OB)rcsfnms.obj :      rcsfnms.c   rcsbase.h   conf.h
$(OB)rcsgen.obj :       rcsgen.c    rcsbase.h   conf.h
$(OB)rcskeep.obj :      rcskeep.c   rcsbase.h   conf.h
$(OB)rcskeys.obj :      rcskeys.c   rcsbase.h   conf.h
$(OB)rcslex.obj :       rcslex.c    rcsbase.h   conf.h
$(OB)rcsmap.obj :       rcsmap.c    rcsbase.h   conf.h
$(OB)rcsmerge.obj :     rcsmerge.c  rcsbase.h   conf.h
$(OB)rcsrev.obj :       rcsrev.c    rcsbase.h   conf.h
$(OB)rcssyn.obj :       rcssyn.c    rcsbase.h   conf.h
$(OB)rcstime.obj :      rcstime.c
$(OB)rcsutil.obj :      rcsutil.c   rcsbase.h   conf.h
$(OB)rlog.obj :         rlog.c      rcsbase.h   conf.h
$(OB)version.obj :      version.c
$(OB)vms.obj : vms.c
#
